<?php


/*
 * @version $Id: HEADER 14684 2011-06-11 06:32:40Z remi $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2011 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 --------------------------------------------------------------------------
 */

// Original Author of file: Walid Nouh
// Purpose of file:
// ----------------------------------------------------------------------

if (!defined('GLPI_ROOT')) {
   define('GLPI_ROOT', '../../..');
}

include (GLPI_ROOT . "/inc/includes.php");

checkRight("logs", "r");

if (haveRecursiveAccessToEntity(0)) {
   commonHeader($LANG["massocsimport"]["common"][1], $_SERVER["PHP_SELF"], "plugins", "massocsimport");

   $thread = new PluginMassocsimportThread();
   
   if (isset ($_POST["delete_processes"])) {
      checkRight("ocsng", "w");
   
      if (count($_POST["item"])) {
         foreach ($_POST["item"] as $key => $val) {
            $thread->deleteThreadsByProcessId($key);
         }
      }
      glpi_header($_SERVER['HTTP_REFERER']);
   
   } else {
      $thread->showProcesses($_SERVER["PHP_SELF"]);
   }
   commonFooter();
}
else {
   glpi_header(getItemTypeSearchURL('PluginMassocsimportNotImported'));
}

?>

